# Street View Publish API

Publishes 360 photos to Google Maps, along with position, orientation, and connectivity metadata. Apps can offer an interface for positioning, connecting, and uploading user-generated Street View images.

- [REST Resource: v1.photo](https://developers.google.com/streetview/publish/reference/rest#v1.photo)
- [REST Resource: v1.photoSequence](https://developers.google.com/streetview/publish/reference/rest#v1.photoSequence)
- [REST Resource: v1.photoSequences](https://developers.google.com/streetview/publish/reference/rest#v1.photoSequences)
- [REST Resource: v1.photos](https://developers.google.com/streetview/publish/reference/rest#v1.photos)

## Service: streetviewpublish.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://streetviewpublish.googleapis.com/$discovery/rest?version=v1>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://streetviewpublish.googleapis.com`

## REST Resource: [v1.photo](https://developers.google.com/streetview/publish/reference/rest/v1/photo)

| Methods ||
|---|---|
| `https://developers.google.com/streetview/publish/reference/rest/v1/photo/create` | `POST /v1/photo` After the client finishes uploading the photo with the returned `https://developers.google.com/streetview/publish/reference/rest/v1/photo#UploadRef`, `https://developers.google.com/streetview/publish/reference/rest/v1/photo/create#google.streetview.publish.v1.StreetViewPublishService.CreatePhoto` publishes the uploaded `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo` to Street View on Google Maps. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photo/delete` | `DELETE /v1/photo/{photoId}` Deletes a `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo` and its metadata. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photo/get` | `GET /v1/photo/{photoId}` Gets the metadata of the specified `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo`. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photo/startUpload` | `POST /v1/photo:startUpload` Creates an upload session to start uploading photo bytes. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photo/update` | `PUT /v1/photo/{photo.photoId.id}` Updates the metadata of a `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo`, such as pose, place association, connections, etc. |

## REST Resource: [v1.photoSequence](https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence)

| Methods ||
|---|---|
| `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create` | `POST /v1/photoSequence` After the client finishes uploading the `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create#PhotoSequence` with the returned `https://developers.google.com/streetview/publish/reference/rest/v1/photo#UploadRef`, `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create#google.streetview.publish.v1.StreetViewPublishService.CreatePhotoSequence` extracts a sequence of 360 photos from a video or Extensible Device Metadata (XDM, <http://www.xdm.org/>) to be published to Street View on Google Maps. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/delete` | `DELETE /v1/photoSequence/{sequenceId}` Deletes a `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create#PhotoSequence` and its metadata. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/get` | `GET /v1/photoSequence/{sequenceId}` Gets the metadata of the specified `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create#PhotoSequence` via the `https://developers.google.com/streetview/publish/reference/rest/v1/Operation` interface. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/startUpload` | `POST /v1/photoSequence:startUpload` Creates an upload session to start uploading photo sequence data. |

## REST Resource: [v1.photoSequences](https://developers.google.com/streetview/publish/reference/rest/v1/photoSequences)

| Methods ||
|---|---|
| `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequences/list` | `GET /v1/photoSequences` Lists all the `https://developers.google.com/streetview/publish/reference/rest/v1/photoSequence/create#PhotoSequence` that belong to the user, in descending CreatePhotoSequence timestamp order. |

## REST Resource: [v1.photos](https://developers.google.com/streetview/publish/reference/rest/v1/photos)

| Methods ||
|---|---|
| `https://developers.google.com/streetview/publish/reference/rest/v1/photos/batchDelete` | `POST /v1/photos:batchDelete` Deletes a list of `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo` and their metadata. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photos/batchGet` | `GET /v1/photos:batchGet` Gets the metadata of the specified `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo` batch. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photos/batchUpdate` | `POST /v1/photos:batchUpdate` Updates the metadata of `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo`, such as pose, place association, connections, etc. |
| `https://developers.google.com/streetview/publish/reference/rest/v1/photos/list` | `GET /v1/photos` Lists all the `https://developers.google.com/streetview/publish/reference/rest/v1/photo#Photo` that belong to the user. |